<?php 
require_once(__DIR__ . "/library/init.php");

$client = (object) WHMCS\Database\Capsule::table("tblclients")->where("email", "mailverify@mailverify.com")->first();
$client = $client->id;
if(empty($client)){
	localAPI("AddClient", 
		array( 
			"firstname" => "Mail", 
			"lastname" => "Verify", 
			"email" => "mailverify@mailverify.com", 
			'address1' => 'address1',
			'city' => 'city',
			'state' => 'state',
			'postcode' => '12345',
			'country' => 'CN',
			'phonenumber' => '18023332333',
			"password2" => MailVerify\Tools::getRandToken(), 
			"notes" => "这个是 [ 强制邮箱验证 ] 模块所需的虚拟账户，请勿删除" ), MailVerify\Tools::getAdminUser()
	);
	unset($_SESSION["uid"]);
}

function MailVerify_Config(){
	$result = array( 
		"name" => "强制邮箱验证", "description" => "本软件基于 WHMCS 的强制邮件验证扩展模块，可实现在原有 WHMCS 的基础上、对邮箱进行强制验证", 
		"version" => "1.0.0", 
		"author" => MailVerify\Tools::getLinkTag("https://www.loli.ren", "奇怪世界", "font-weight: bold;"), 
		"fields" => array(
			"suffix" => array( "FriendlyName" => "可用后缀", "Type" => "textarea", "Default" => "qq.com, 163.com", "Rows" => 5 ) 
		) 
	);
	return $result;
}

function MailVerify_Activate(){
	$sql = "
	CREATE TABLE IF NOT EXISTS `mod_mailverify` (
	  `email` varchar(128) NOT NULL,
	  `token` varchar(128) NOT NULL,
	  `number` int(11) NOT NULL,
	  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP
	) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
	";
	$sql1 = "
	ALTER TABLE `mod_mailverify`
	  ADD PRIMARY KEY (`email`),
	  ADD UNIQUE KEY `email` (`email`),
	  ADD UNIQUE KEY `token` (`token`);
	";
	try{
		WHMCS\Database\Capsule::select(WHMCS\Database\Capsule::raw($sql));
		WHMCS\Database\Capsule::select(WHMCS\Database\Capsule::raw($sql1));
		return array( "status" => "success", "description" => "成功启用 [ 强制邮箱验证 ] 模块" );
	}catch( Exception $e ) {
		return array( "status" => "error", "description" => "启用失败，数据表导入错误" );
	}
}

function MailVerify_DeActivate(){
	try{
		WHMCS\Database\Capsule::select(WHMCS\Database\Capsule::raw("DROP TABLE `mod_mailverify`;"));
		return array( "status" => "success", "description" => "成功关闭 [ 强制邮箱验证 ] 模块" );
	}catch( Exception $e ) {
		return array( "status" => "error", "description" => "关闭失败，相应的数据表不存在" );
	}
}

function MailVerify_clientarea($vars){
	$templatefile = "error";
	$return = array(
		'title' => '出现错误',
		'message' => '未知错误'
	);
	$client = (object) WHMCS\Database\Capsule::table("tblclients")->where("email", "mailverify@mailverify.com")->first();
	$client = $client->id;
	if(empty($client)){
		$templatefile = "error";
		$return = array(
			'title' => '出现错误',
			'message' => '未发现 [ 强制邮箱验证 ] 模块所需的虚拟账户，请重试'
		);
	}else{
		$suffix = str_replace(" ", "", $vars['suffix']); 
		$suffix = explode(",", $suffix);
		if($suffix[0] == ""){
			$templatefile = "error";
			$return = array(
				'title' => '出现错误',
				'message' => '未发现 [ 强制邮箱验证 ] 模块所需的邮件后缀，请重试'
			);
		}else{
			if(isset($_POST['email']) && isset($_POST['suffix'])){
				if(in_array($_POST['suffix'], $suffix)){
					$email = $_POST['email'] . "@" . $_POST['suffix'];
					$result = WHMCS\Database\Capsule::table('tblclients')->where('email', $email)->first();
					if($result){
						$return = array(
							'title' => '出现错误',
							'message' => '邮箱账号 [ ' . $email . ' ] 已存在，若忘记密码、请重置密码'
						);
					}else{
						$result = WHMCS\Database\Capsule::table('mod_mailverify')->where('email', $email)->first();
						$token = MailVerify\Tools::getRandToken();
						if(!$result){
							WHMCS\Database\Capsule::table('mod_mailverify')->insert(['email' => $email, 'token' => $token, 'number' => "1", 'date' => date("Y-m-d H:i:s",time())]);
							$return = MailVerify_sendMail($email, $token, $client, $vars);
						}else{
							if($result->number < 5){
								$number = $result->number + 1;
								WHMCS\Database\Capsule::table('mod_mailverify')->where('email', $email)->update(['token' => $token, 'number' => $number, 'date' => date("Y-m-d H:i:s",time())]);
								$return = MailVerify_sendMail($email, $token, $client, $vars);
							}else{
								$return = array(
									'title' => '出现错误',
									'message' => '当前邮箱 ' . $email . ' 已频繁发信超过 5 次，请明天再来吧'
								);
							}
						}
						if($return === true){
							$templatefile = "register";
						}
					}
				}else{
					$return = array(
						'title' => '错误',
						'message' => '非法的邮件后缀，请重试'
					);
				}
			}elseif(isset($_GET['action']) && isset($_GET['token'])){
				$result = WHMCS\Database\Capsule::table('mod_mailverify')->where('token', $_GET['token'])->first();
				if($result){
					$oldtime = strtotime($result->date);
					if(time() - $oldtime <= 60 * 10){
						if(isset($_POST['firstname']) && isset($_POST['lastname']) && isset($_POST['password'])){
							$results = localAPI("AddClient", 
								array(
								'firstname' => $_POST['firstname'],
								'lastname' => $_POST['lastname'],
								'email' => $result->email,
								'address1' => 'address1',
								'city' => 'city',
								'state' => 'state',
								'postcode' => '12345',
								'country' => 'CN',
								'phonenumber' => '18023332333',
								'password2' => $_POST['password'],
							), MailVerify\Tools::getAdminUser());
							if($results['result'] == "success"){
								WHMCS\Database\Capsule::table('mod_mailverify')->where('email', $result->email)->delete();
								$return = array(
									'title' => '注册成功',
									'message' => '感谢你的注册～'
								);
							}
						}else{
							$templatefile = "verify";
							$return = array(
								'email' => $result->email
							);
						}
					}else{
						$return = array(
							'title' => '出现错误',
							'message' => '链接已失效，验证时间已超过 10 分钟'
						);
					}
				}else{
					$return = array(
						'title' => '出现错误',
						'message' => '当前访问的验证链接已失效或不存在'
					);
				}
			}else{
				$templatefile = "register";
				$return = array(
					'suffix' => $suffix,
					'params' => array(
						'modulelink' => $vars['modulelink']
					)
				);
			}
		}
	}
	return array(
		'pagetitle' => '邮件验证',
		'templatefile' => 'library/theme/client/' . $templatefile . '.tpl',
		'requirelogin' => false,
		'vars' => $return
	);
}

function MailVerify_sendMail($email, $token, $client, $vars){
	$return = array(
		'title' => '出现错误',
		'message' => '邮件发送失败，请稍后重试'
	);
	$results = localAPI("UpdateClient", 
	array(
		'clientid' => $client,
		'email' => $email,
	), MailVerify\Tools::getAdminUser());
	if($results['result'] == "success"){
		$reglink = MailVerify\Tools::getSystemURL() . $vars['modulelink'] . "&action=verify&token=" . $token;
		$results1 = localAPI("SendEmail", 
			array(
				'messagename' => '完成你的注册',
				'id' => $client,
				'customtype' => 'general',
				'customsubject' => '完成你的注册',
				'custommessage' => '<p>请点击以下链接完成注册</p><p>' . $reglink . '</p>'
		), MailVerify\Tools::getAdminUser());
		$results = localAPI("UpdateClient", 
		array(
			'clientid' => $client,
			'email' => 'mailverify@mailverify.com',
		), MailVerify\Tools::getAdminUser());
		if($results['result'] == "success" && $results1['result'] == "success"){
			$return = true;
		}
	}
	return $return;
}